﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Net;
using System.IO;

using System.Web; //Add reference to System.Web
using System.Runtime.Serialization.Json; //Add reference to System.Runtime.Serialization

namespace RedCritterConnecter.Samples
{
    //Create a class to contain the response

    public class GetUserProfileByAppDomainResponse
    {
        public String Username { get; set; }
        public String FirstName { get; set; }
        public String LastName { get; set; }
        public String Title { get; set; }
        public Boolean Result { get; set; }
      
    }

    public class GetUserProfileByAppDomain
    {

        public delegate void OnGetUserProfileByAppDomainResponse(GetUserProfileByAppDomainResponse GetUserProfileByAppDomainResponse);
        public event OnGetUserProfileByAppDomainResponse onGetUserProfileByAppDomainResponse;

        public delegate void OnGetUserProfileByAppDomainResponseError(GetUserProfileByAppDomainResponse GetUserProfileByAppDomainResponse);
        public event OnGetUserProfileByAppDomainResponseError onGetUserProfileByAppDomainResponseError;

        const string CONST_ConnecterBaseURL = "https://www.redcritterconnecter.com/";

        public void Execute(String SecretKey, String ProfileEntity, String PublicKeys, String KeyFiltered)
        {
            try
            {
                //Create url encoded parameters in query string
                String queryString = "secretkey=" + System.Web.HttpUtility.UrlEncode(SecretKey) + "&profileentity=" + System.Web.HttpUtility.UrlEncode(ProfileEntity) + "&publickeys=" + System.Web.HttpUtility.UrlEncode(PublicKeys) + "&keyfiltered=" + System.Web.HttpUtility.UrlEncode(KeyFiltered);

                //Create a new instance of a WebClient
                WebClient wc = new System.Net.WebClient();

                //Prevent this request from caching in order to ensure that it is sent to server
                wc.CachePolicy = new System.Net.Cache.RequestCachePolicy(System.Net.Cache.RequestCacheLevel.NoCacheNoStore);

                //Attach an event handler to receive the response
                wc.DownloadStringCompleted += onGetUserProfileByAppDomainResponseReceived;

                //Make the call
                            
                wc.DownloadStringAsync(new Uri(CONST_ConnecterBaseURL + "services/gamificationv1/GetUserProfileByAppDomain?" + queryString, UriKind.Absolute));
            }
            catch
            {
                //Something went wrong communicating with the server
                if (onGetUserProfileByAppDomainResponseError != null)
                {
                    onGetUserProfileByAppDomainResponseError(null);
                }
            }

        }

        private void onGetUserProfileByAppDomainResponseReceived(object sender, DownloadStringCompletedEventArgs e)
        {
            try
            {
                //Create a JSON serializer
                System.Runtime.Serialization.Json.DataContractJsonSerializer s = new DataContractJsonSerializer(typeof(GetUserProfileByAppDomainResponse));
               

                //Copy the string into a memory stream
                MemoryStream ms = new MemoryStream(Encoding.UTF8.GetBytes(e.Result));

                //Read the stream into an object matching the response's type
                GetUserProfileByAppDomainResponse GetUserProfileByAppDomainResponse = (GetUserProfileByAppDomainResponse)s.ReadObject(ms);

                //Work with the populated response object
                if (GetUserProfileByAppDomainResponse.Result == true)
                {
                    //Request was accepted, raise the success event
                    onGetUserProfileByAppDomainResponse(GetUserProfileByAppDomainResponse);
                }
                else
                {
                    //Something went wrong
                    if (onGetUserProfileByAppDomainResponseError != null)
                    {
                        //Request failed, raise the error event
                        onGetUserProfileByAppDomainResponseError(GetUserProfileByAppDomainResponse);
                    }
                }
            }
            catch
            {
                //Something went wrong
                onGetUserProfileByAppDomainResponseError(null);
            }
        }
    }
}
